//Copyright (c) 2012 NS BASIC Corporation. All rights reserved.
//Helper functions

var True=true; TRUE=true;
var False=false; FALSE=false;
var _jsString=String; //allow javascript string object to be in vbScript code
var _JSSTRING=_jsString; _jsSTRING=_jsString; _jsstring=_jsString;
var savethefunction_rvar=null;
var _nsbJSONsqlData='';
var _nsbJSONSchemaText='';
var _nsbJSONSchemaDB=null;
//vbScript GetRef function: GetRef(sub name)
function getRef(str) {
	if (typeof(str)=='string') {
		return eval(str);
	} else {
		return str;
	}
} var GetRef=getRef; var getref=getRef; var GETREF=getRef;
		 
//MsgBox function to handle proper return variables since JavaScript returns true or false from CONFIRM box
function _msgbox_confirm(prompt, buttons, title, helpfile, context) {
	if (prompt == false || prompt == 0) {
		//do nothing and use the 'false' or '0' value
	} else {
		if (!prompt || prompt==null || typeof(prompt)=='undefined') { prompt = ''; }
	}
	if (!buttons || buttons==null || typeof(buttons)=='undefined' || buttons=='') { buttons = 0; }
	if (buttons == parseInt(buttons) && buttons == parseFloat(buttons)) { buttons = buttons & 0x000F; }
	
	var res = 1;
	switch (buttons) {
		case 1: //vbOKCancel - OK (1) and Cancel (2)
			res = confirm(prompt);
			if (res == true) { return 1; } else { return 2; }
			break;
		case 2: //vbAbortRetryIgnore - Abort (3), Retry (4), and Ignore (5)
			res = confirm(prompt);
			if (res == true) { return 4; } else { return 5; }
			break;
		case 3: //vbYesNoCancel - Yes (6), No (7), and Cancel (2)
			res = confirm(prompt);
			if (res == true) { return 6; } else { return 7; }
			break;
		case 4: //vbYesNo - Yes (6) and No (7)
			res = confirm(prompt);
			if (res == true) { return 6; } else { return 7; }
			break;
		case 5: //vbRetryCancel - Retry (4) and Cancel (2)
			res = confirm(prompt);
			if (res == true) { return 4; } else { return 2; }
			break;
		default: //0 = vbOKOnly - OK (1)
			alert(prompt);
			return 1;
			break;
	}
}
		 
//vbScript mid syntax: mid(string1, start[,end])
// string1: string to cust from; start: start of cut; end: end of cut (if no end, then to end of string1)
function Mid(strMid, intBeg, intEnd) {
	//setup variables in case there is no intEnd (optional value in vbScript)
	if (strMid==null || strMid=="" || intBeg < 0) { return ''; }
	intBeg -= 1; //reset vbScript 1 base
	if (intEnd==null || intEnd=="") {
		return strMid.substr(intBeg);
	} else {
		return strMid.substr(intBeg,intEnd);
	}
} var mid=Mid; var MID=Mid; var midb=Mid; var MidB=mid; var Midb=Mid; var MIDB=Mid; var midB=Mid;

//vbScript Right function: Right(str,len)
function Right(str, n) {
	var s=str + '';
	var iLen = s.length;
	if (n <= 0) {
		return "";
	} else if (n >= iLen) {
		return s;
	} else {
		return s.substr(iLen-n, n);
	}
} var right=Right; var rightb=Right; var Rightb=Right; var RightB=Right; var rightB=Right; var RIGHT=Right; //so all cases work for the function name

//vbScript Left function: Left(str,len)
function Left(str, n) {
	var s=str + '';
	var iLen = s.length;
	if (n <= 0) {
		return "";
	} else if (n >= iLen) {
		return str;
	} else {
		return s.substr(0,n);
	}
} var left=Left; var leftb=Left; var Leftb=Left; var LeftB=Left; var leftB=Left; var LEFT=Left;

//vbScript RTrim function: RTrim(str)
function RTrim(str) {
	var whitespace = " \t\n\r";
	var s = str;
	if (whitespace.indexOf(s.charAt(s.length-1)) != -1) {
		var i = s.length - 1;       // Get length of string
		while (i >= 0 && whitespace.indexOf(s.charAt(i)) != -1) { i--; }
		s = s.substring(0, i+1);
	}
	return s;
} var rtrim=RTrim; var rTrim=RTrim; var Rtrim=RTrim; var RTRIM=RTrim; //so both cases work for the function name

//vbScript LTrim function: LTrim(str)
function LTrim(str) {
	var whitespace = " \t\n\r";
	var s = str;
	if (whitespace.indexOf(s.charAt(0)) != -1) {
		var j=0, i = s.length;
		while (j < i && whitespace.indexOf(s.charAt(j)) != -1) { j++; }
		s = s.substring(j, i);
	}
	return s;
} var ltrim=LTrim; var lTrim=LTrim; var Ltrim=LTrim; var LTRIM=LTrim;

//vbScript Trim
function Trim(str) {
	return LTrim(RTrim(str));
} var trim=Trim; var TRIM=Trim;

//vbScrtip Sgn
function Sgn(val) {
	/*	>0 - Sgn returns 1
		=0 - Sgn returns 0
		<0 - Sgn returns -1
	*/
	if (typeof(val)=='string') { val=parseFloat(val); }
	if (val == 0) { return 0; }
	if (val < 0) { return -1; }
	return 1;
} var sgn=Sgn; var SGN=Sgn;

//vbScript Len function: Len(str)
function Len(str) {
	if (typeof(str)=='object') { return str.length; }
	str=str + '';
	return str.length;
} var len=Len; var LEN=Len; var lenb=Len; var Lenb=Len; var LenB=Len; var LENB=Len; var lenB=Len;

//vbScript Replace function: Replace(string,find,replacewith[,start[,count[,compare]]]) 
function Replace(str, fnd, rpl, st, cnt, cmp) {
	if (st==null || st=="" || st < 0) { st=1; }
	st -= 1;
	if (cnt==null || cnt=="" || cnt < 0) { cnt=0; }
	if (st >= 0) { str=str.substr(st,str.length); }
	fnd=fnd.replace(/([\$\^\[\(\)\*\+\?\.\\])/g,'\\$1');
	if (cnt > 0) {
		var regex=new RegExp(fnd);
		for (var i=0; i<cnt; i++) {
			str =str.replace(regex,rpl);
		}
	} else {
		var regex=new RegExp(fnd,'g');
		str = str.replace(regex,rpl);
	}
	return str;
} var replace=Replace; var REPLACE=Replace;

function Replace2(str, fnd, rpl, st, cnt, cmp) {
  	var regex=new RegExp(fnd,'g');
  	return str.replace(regex,rpl);
	//return str.replace(fnd, rpl);
} replace=Replace; REPLACE=Replace;

//vbScript StrReverse function: StrReverse(str)
function StrReverse(s) {
	var sArray = s.split("");
	var rArray=sArray.reverse();
	return rArray.join("");
} var strreverse=StrReverse; var strReverse=StrReverse; var STRREVERSE=StrReverse;

//vbScript WeekdayName function: WeekdayName(dow[,true/false[,offset]])
function WeekdayName_del(dow,tf,st) {
	var weekday=new Array(nsbx.messages["Sunday"],nsbx.messages["Monday"],nsbx.messages["Tuesday"],nsbx.messages["Wednesday"],nsbx.messages["Thursday"],nsbx.messages["Friday"],nsbx.messages["Saturday"]);
	var dd="";
	if (dow>=1 && dow<=7) {
		dow--;
		if (st>=1 && st<=7) {
			st--;
		} else {
			st=0;
		}
		if (dow+st>6) {
			dow=(dow+st)-7;
			st=0;
		}
		dd=weekday[dow+st];
		if (tf==true) {
			dd=dd.substring(0,3);
		}
	}
	return dd;
} //weekdayname=WeekdayName;WeekDayName=WeekdayName;weekDayName=WeekdayName;WEEKDAYNAME=WeekdayName;

//vbScript Year function: Year(date)
function Year(dt) {
  	var regex=new RegExp('-','g');
  	dt=dt.replace(regex,'/');
	var dat=new Date(dt);
	return dat.getFullYear();
} var year=Year; var YEAR=Year;

function Sort(arrayToSort, sortType, sortFunc) {
	//arguments: array to sort, sort type (a=ascending, d=descending), sort function (for custom functions--parameter for sort function is arrayToSort)
	//syntax: 	sort(arrayToSort)				<-- sortType defaulted to ascending
	//			sort(arrayToSort,'')			<-- sortType defaulted to ascending
	//			sort(arrayToSort,'d')			<-- descending sort
	//			sort(arrayToSort,'a')			<-- ascending sort
	//			sort(arrayToSort,'d',sortFunc)	<-- function sortFunc called with argument arrayToSort; function will return sorted array; sortType ignored
	//			sort(arrayToSort,sortFunc)		<-- function sortFunc called with argument arrayToSort; function will return sorted array
	if (!sortType || sortType==null || typeof(sortType)=='undefined') {sortType='';}
	if (!sortFunc || sortFunc==null || typeof(sortFunc)=='undefined' || typeof(sortFunc)!='function') {sortFunc='';}
	if (typeof(sortType)=='function' && sortFunc=='') {
		sortFunc = sortType;
		sortType = 'a';
	} else {
		if (sortType != 'd') {sortType='a';}
	}
	this._sortType=sortType;
	var arr = arrayToSort.slice();
	var ret = [];
	if (sortFunc=='' || typeof(sortFunc)!='function') {
		arr.sort();
		arr.sort(_sort1);
		ret=arr.slice();
	} else {
		//ret = sortFunc(arr).slice();
		ret=arr.sort(sortFunc);
	}
	return ret;

	function _sort1(a,b) {
		if ( _isNumber(a) && _isNumber(b) ) {
			if (this._sortType=='d') {
			y=a*1; x=b*1;
			} else {
			x=a*1; y=b*1;
			}
			return ((x < y) ? -1 : ((x > y) ? 1 : 0));
		} else if ( _isNumber(a) && !_isNumber(b) ) {
			x=a*1; y=b;
			return (this._sortType=='d' ? 1 : -1);
		} else if ( !_isNumber(a) && _isNumber(b) ) {
			x=a; y=b*1;
			return (this._sortType=='d' ? -1 : 1);
		} else {
			if (this._sortType=='d') {
				y=a.toLowerCase(); x=b.toLowerCase();
			} else {
				x=a.toLowerCase(); y=b.toLowerCase();
			}
			return ((x > y) ? 1 : (x===y?0:-1) );
		}
	}
	function _isNumber(n) { return !isNaN(parseFloat(n)) && isFinite(n); }
}

//vbScript IsNumeric function: IsNumeric(var)
function IsNumeric(sText) {
   return !isNaN(sText);
} var isnumeric=IsNumeric; var isNumeric=IsNumeric; var ISNUMERIC=IsNumeric;

//vbscribt Asc function: Asc(char)
function Asc(c) {
	c = c . charAt (0);
	var i;
	for (i = 0; i < 256; ++ i) {
		var h = i . toString (16);
		if (h . length == 1)
			h = "0" + h;
		h = "%" + h;
		h = unescape (h);
		if (h == c)
			break;
	}
	return i;
} var asc=Asc; var ASC=Asc; var ASCB=Asc; var ASCW=Asc; var ascB=Asc; var ascW=Asc; var ascw=Asc; var ascb=Asc;

//vbScript CByte/CLng/CInt function: CByte(n)
function CByte(n) {
	var i=n*1;
	i=Math.round(i);
	//odd numbers round up if .5, even numbers don't
	if (i%2 != 0) {
		var j=Math.abs(n-i);
		if (j==.5) {i-=1;}
	}
	return i;
} var cbyte=CByte; var CBYTE=CByte; var CInt=CByte; var CINT=CByte; var CLng=CByte; var CLNG=CByte; var clng=CByte; var cint=CByte; var CINT=CByte;

//vbScript ROUND
function ROUND(n,d) {
	if (!d || d==null || d=="") {d=0;}
	d=Math.floor(d);
	d=d<1?0:d;
	d=Math.pow(10,d);
	var result=Math.round(n*d) / d;
	return result;
} var Round=ROUND; var round=ROUND;

//vbScript CCur function: CCur(n) round to 4 decimal places
function CCur(num) {
	var dec=4;
	var result = Math.round(num*Math.pow(10,dec))/Math.pow(10,dec);
	return result;
} var ccur=CCur; var CCUR=CCur; var cCur=CCur;

//vbScript CSng function: CSng(n) round to 3 decimal places
function CSng(num) {
	var dec=3;
	var result = Math.round(num*Math.pow(10,dec))/Math.pow(10,dec);
	return result;
} var csng=CSng; var CSNG=CSng;

//vbScript imp functionality
function impFunc(a,b) {
	var val1=a?1:0;
	var val2=b?1:0;
	if (val1==1 && val2==1) return true;
	if (val1==1 && val2==0) return false;
	if (val1==0 && val2==1) return true;
	if (val1==0 && val2==0) return true;
	if (a==null && val2==1) return true;
	return null;
} var IMPFUNC=impFunc; var ImpFunc=impFunc;

//vbScript exp functionality
function eqvFunc(a,b) {
	if (a==true && b==true || a==false && b==false) {
		return true;
	} else {
		return false;
	}
} var EQVFUNC=eqvFunc; var EqvFunc=eqvFunc;

//convertDate helper function
function convertDate(dt,convertMonth) {
	if(typeof(dt)=='object') {return dt;}
	if (dt==null || dt=='') {return null;}
	//new Date format
	dt=dt.toString();
	if (dt.match(/\s*\w{3}\s+\w{3}\s+\d{2}\s+\d{4}\s+\d{2}:\d{2}:\d{2}\s+\w{3}[\+\-]\d{4}/) ) {
		if (convertMonth != 1) {
			return dt.replace(/\s*\w{3}\s+(\w{3})\s+(\d{2})\s+(\d{4})\s+(\d{2}:\d{2}:\d{2}).*/, '$1 $2, $3 $4');
		} else {
			dt=dt.replace(/\s*\w{3}\s+(\w{3})\s+(\d{2})\s+(\d{4})\s+(\d{2}:\d{2}:\d{2}).*/, '$2 $1 $3 $4');
		}
	}
	
	if (dt.match(/\s*(\d{1,2})(\s+|\s*\-\s*)([a-z]{3})(\s+|\s*\-\s*)(\d{2})($|\s+)/i)) {
		dt=dt.replace(/\s*(\d{1,2})(\s+|\s*\-\s*)([a-z]{3})(\s+|\s*\-\s*)(\d{2})($|\s+)/i,'$1 $3 20$5$6');
	}
	if (dt.match(/\s*\d{4}[\/\-]\d{1,2}[\/\-]\d{1,2}/)) {
		dt=dt.replace(/\s*(\d{4})[\/\-](\d{1,2})[\/\-](\d{1,2})/,'$2-$3-$1');
	}
	if (!dt.match(/\s*\d{1,2}(\s+|\s*\-\s*)[a-z]{3}(\s+|\s*\-\s*)(\d{2}|\d{4})\s*/i)) {
		if(!dt.match(/\s*[a-z]+\s+\d{1,2},?\s+(\d{2}|\d{4})\s*/i)) {
			dt=dt.replace(/\-/g,'/').replace(/\;/g,'/').replace(/\s+/g,'/').replace(/\./g,'/').replace(/,/g,'/').replace(/\/+/g,'/');
			if (!dt.match(/\d{1,2}\/\d{1,2}\/(\d{2}|\d{4})/)) {
				return null;
			}
		}
	}
	if (convertMonth==1) {
		var smon=[nsbx.messages['Jan'],nsbx.messages['Feb'],nsbx.messages['Mar'],nsbx.messages['Apr'],nsbx.messages['May'],nsbx.messages['Jun'],nsbx.messages['Jul'],nsbx.messages['Aug'],nsbx.messages['Sep'],nsbx.messages['Oct'],nsbx.messages['Nov'],nsbx.messages['Dec']];
		var dmon=dt.replace(/(\w+)(\s+)(\w+)(\s+)(\w+)(\s+)(\S+)/,'$3')
		var nmon=0;
		for (i=0; i<smon.length; i++) {
			if (dmon==smon[i]) {
				nmon=i+1;
				break;
			}
		}
		dt=nmon+dt.replace(/(\w+)(\s+)(\w+)(\s+)(\w+)(\s+)(\S+)/,'/$1/$5 $7');
	} else {
		var sdt=dt;
		dt=dt.replace(/(\d+)(\s+|\/)([a-zA-Z]{3,})(\s+|\/)(\d+)(\s+|\/)(\w+)(\s+|\/|\:)(\w+)(\s+|\/|\:)(\w+)(\s+|\/|)([apAP][mM])/,'$1 $3 $5 $7:$9:$11 $13');
		if (sdt==dt) {
			dt=dt.replace(/(\d+)(\s+|\/)([a-zA-Z]{3,})(\s+|\/)(\d+)(\s+|\/)(\w+)(\s+|\/|\:)(\w+)(\s+|\/|)([apAP][mM])/,'$1 $3 $5 $7:$9 $11');
		}
		if (sdt==dt) {
			dt=dt.replace(/(\d+)(\s+|\/)([a-zA-Z]{3,})(\s+|\/)(\d+)(\s+|\/)(\w+)(\s+|\/|\:)(\w+)(\s+|\/|\:)(\w+)/,'$1 $3 $5 $7:$9:$11');
		}
		if (sdt==dt) {
			dt=dt.replace(/(\d+)(\s+|\/)([a-zA-Z]{3,})(\s+|\/)(\d+)(\s+|\/)(\w+)(\s+|\/|\:)(\w+)/,'$1 $3 $5 $7:$9');
		}
		if (sdt==dt) {
			dt=dt.replace(/(\w+)(\s+|\/)(\w+)(\s+|\/)(\w+)(\s+|\/)(\w+)(\s+|\/|\:)(\w+)(\s+|\/|\:)(\w+)(\s+|\/|)([apAP][mM])/,'$1/$3/$5 $7:$9:$11 $13');
		}
		if (sdt==dt) {
			dt=dt.replace(/(\w+)(\s+|\/)(\w+)(\s+|\/)(\w+)(\s+|\/)(\w+)(\s+|\/|\:)(\w+)(\s+|\/|)([apAP][mM])/,'$1/$3/$5 $7:$9 $11');
		}
		if (sdt==dt) {
			dt=dt.replace(/(\w+)(\s+|\/)(\w+)(\s+|\/)(\w+)(\s+|\/)(\w+)(\s+|\/|\:)(\w+)(\s+|\/|\:)(\w+)/,'$1/$3/$5 $7:$9:$11');
		}
		if (sdt==dt) {
			dt=dt.replace(/(\w+)(\s+|\/)(\w+)(\s+|\/)(\w+)(\s+|\/)(\w+)(\s+|\/|\:)(\w+)/,'$1/$3/$5 $7:$9');
		}
	}
	return dt;
} var CONVERTDATE=convertDate; var ConvertDate=convertDate;

//vbScript IsDate function: IsDate(date string)
function IsDate(dt) {
	if (typeof(dt) != 'object' && isNumeric(dt)) { return false; }
	var cdt=convertDate(dt,0);
	return !isNaN(new Date(cdt));
} var isdate=IsDate; var isDate=IsDate; var ISDATE=IsDate;

//vbScript CDate
function CDate(dt) {
    if (typeof(dt)==undefined) {return 'undefined'};
    if (IsDate(dt)) {
		if (VARTYPE(dt.toString(),1) == 'date') {
			return FormatDateTime(dt,2); //date
		}
		if (dt.toString().indexOf(':') > -1) {
			return FormatDateTime(dt,3); //time
		} else {
			return FormatDateTime(dt,2); //date
		}
	} else {
		return null;
	}
} var cdate=CDate; var cDate=CDate; var Cdate=CDate; var CDATE=CDate;

function CvDate(dt) {
	if (IsDate(dt)) {
		return new Date(convertDate(dt,0));
	} else {
		return null;
	}
} var cvdate=CvDate; var cvDate=CvDate; var Cvdate=CvDate; var CVDATE=CvDate;

//vbScript dateadd function: DateAdd(interval,number,date)
function DateAdd(dint, numval, thedate) {
	if(!CvDate(thedate)){	return null;	}
	if(isNaN(numval)){	return null;	}	

	numval = new Number(numval);
	var dt = CvDate(thedate);
	
	switch(dint.toLowerCase()){
		case "yyyy": {
			dt.setFullYear(dt.getFullYear() + numval);
			break;
		}
		case "q": {
			var omon=dt.getMonth();
			dt.setMonth(dt.getMonth() + (numval*3));
			//fix problem with end of month date not correct for new month
			var nmon=dt.getMonth();
			var rmon=omon+(numval*3)<0?12+(omon+(numval*3)):omon+(numval*3);
			if (rmon != nmon) {
				dat=dt.getDate();
				dt.setDate(dt.getDate() - dat);
			}
			break;
		}
		case "m": {
			var omon=dt.getMonth();
			dt.setMonth(dt.getMonth() + numval);
			//fix problem with end of month date not correct for new month
//			nmon=dt.getMonth();
//			rmon=omon+numval<0?12+(omon+numval):omon+numval;
//			if (rmon != nmon) {
//				dat=dt.getDate();
//				dt.setDate(dt.getDate() - dat);
//			}
			break;
		}
		case "y":
		case "d":
		case "w": {	
			dt.setDate(dt.getDate() + numval);
			break;
		}
		case "ww": {
			dt.setDate(dt.getDate() + (numval*7));
			break;
		}
		case "h": {
			dt.setHours(dt.getHours() + numval);
			break;
		}
		case "n": {
			dt.setMinutes(dt.getMinutes() + numval);
			break;
		}
		case "s": {
			dt.setSeconds(dt.getSeconds() + numval);
			break;
		}
		case "ms": {
			dt.setMilliseconds(dt.getMilliseconds() + numval);
			break;
		}
		default: {
			return null;
			break;
		}
	}
	var fdt = FormatDateTime(dt,2) + " " + FormatDateTime(dt,3);
	return fdt;
} var dateadd=DateAdd; var dateAdd=DateAdd; var DATEADD=DateAdd;

//vbScript datepart function: DatePart(interval,date[,firstdayofweek[,firstweekofyear]])
function DatePart(dint, thedate, fdow) {
	var d;
	//if(fdow==null) fdow=1;
	d=CvDate(thedate);
	if(!d){	return null;	}
	var dtPart = d;
	var leapYearAdj=0;
	if (_testLeapYear(dtPart.getFullYear())) {
		//test if leap year and past 2/28
		if ( dtPart.getMonth()>1 || (dtPart.getMonth()==1 && dtPart.getDate()>28) ) { leapYearAdj=1; } //adjust for leap year
	}
	
	if (!dint || dint==null) return null;
	switch(dint.toLowerCase()){
		case "yyyy": return dtPart.getFullYear();
		case "q": return Math.floor(dtPart.getMonth() / 3) + 1;
		case "m": return dtPart.getMonth() + 1;
		case "y": return DateDiff("y", "1/1/" + dtPart.getFullYear(), dtPart) + 1 + leapYearAdj;	// day of year
		case "d": return dtPart.getDate();
		case "w": return Weekday(dtPart.getDay()+1, fdow);		// weekday
		case "ww":return DateDiff("ww", "1/1/" + dtPart.getFullYear(), dtPart, fdow) + 1;	// week of year
		case "h": return dtPart.getHours();
		case "n": return dtPart.getMinutes();
		case "s": return dtPart.getSeconds();
		case "ms":return dtPart.getMilliseconds();	// <-- JS extension, NOT in vbScript
		default : return null;
	}
} var datepart=DatePart; var datePart=DatePart; var DATEPART=DatePart;

function _testLeapYear(yr) {
	//test if leap year
	if ((parseInt(yr)%4) == 0) {
		if (parseInt(yr)%100 == 0) {
			if (parseInt(yr)%400 != 0) {
				return false;
			}
			if (parseInt(yr)%400 == 0) {
				return true;
			}
		}
		if (parseInt(yr)%100 != 0) {
			return true;
		}
	}
	if ((parseInt(yr)%4) != 0) {
		return false;
	}
}

// adjusts weekday for week starting on fdow
function Weekday(wd, fdow) {
	var vbSunday=1;
	fdow = (isNaN(fdow) || fdow==0) ? vbSunday : Math.floor(fdow);	// set default & cast
	if (!isObject(wd)) {
		wd=new Date(wd);
	}
	var iDay=wd.getDay()+1;
	return ((iDay - fdow +7) % 7) + 1;
} var weekday=Weekday; var weekDay=Weekday; var WEEKDAY=Weekday;

//vbScript DateDiff function: DateDiff(interval,date1,date2[,firstdayofweek[,firstweekofyear]])
function DateDiff(dint, thedate1, thedate2, fdow) {
	var vbUseSystemDayOfWeek=0; var vbSunday=1; var vbMonday=2; var vbTuesday=3; var vbWednesday=4; var vbThursday=5; var vbFriday=6; var vbSaturday=7;
	if(!CvDate(thedate1)){	return null;	}
	if(!CvDate(thedate2)){	return null;	}
	fdow = (isNaN(fdow) || fdow==0) ? vbSunday : Math.floor(fdow);	// set default & cast

	var dt1 = CvDate(thedate1);
	var dt2 = CvDate(thedate2);

	// correct DST-affected intervals ("d" & bigger)
	//if("h,n,s,ms".indexOf(dint.toLowerCase())==-1){
		//if(thedate1.toString().indexOf(":") ==-1){ dt1.setUTCHours(0,0,0,0) };	// no time, assume 12am
		//if(thedate2.toString().indexOf(":") ==-1){ dt2.setUTCHours(0,0,0,0) };	// no time, assume 12am
	//}

	// get ms between UTC dates and make into "difference" date
	var iDiffMS = dt2.valueOf() - dt1.valueOf();
	var dtDiff = new Date(iDiffMS);

	// calc various diffs
	var nYears  = dt2.getYear() - dt1.getYear();
	var nMonths = dt2.getMonth() - dt1.getMonth() + (nYears!=0 ? nYears*12 : 0);
	var nQuarters = Math.floor(nMonths / 3);	//<<-- different than vbScript, which watches rollover not completion
	
	var nMilliseconds = iDiffMS;
	var nSeconds = Math.floor(iDiffMS / 1000);
	var nMinutes = Math.floor(nSeconds / 60);
	var nHours = Math.floor(nMinutes / 60);
	var nDays  = Math.floor(nHours / 24);
	var nWeeks = Math.floor(nDays / 7);

	if(dint.toLowerCase()=='ww'){
			// set dates to 1st & last FirstDayOfWeek
			var offset = DatePart("w", dt1, fdow)-1;
			if(offset){	dt1.setDate(dt1.getDate() +7 -offset);	}
			var offset = DatePart("w", dt2, fdow)-1;
			if(offset){	dt2.setDate(dt2.getDate() -offset);	}
			// recurse to "w" with adjusted dates
			var nCalWeeks1 = DateDiff("w", dt1, dt2) + 1;
			var nCalWeeks2 = (nDays / 7 == Math.floor(nDays / 7) ) ? nWeeks : nWeeks+1;
			var nCalWeeks = round(nDays / 7);
			//document.write("<br>days: "+nCalWeeks1+', '+nCalWeeks2+', ' + nDays / 7 + ', '+iDiffMS/(1000*60*60*24*7)+', '+nWeeks+'<br>');
	}
	
	// return difference
	switch(dint.toLowerCase()){
		case "yyyy": return nYears;
		case "q": return nQuarters;
		case "m":	return nMonths;
		case "y":			// day of year
		case "d": return nDays;
		case "w": return nWeeks;
		case "ww":return nCalWeeks; // week of year	
		case "h": return nHours;
		case "n": return nMinutes;
		case "s": return nSeconds;
		case "ms":return nMilliseconds;	// not in vbScript
		default : return null;
	}
} var datediff=DateDiff; var dateDiff=DateDiff; var DATEDIFF=DateDiff;

//vbScript Minute
function Minute(tm) {
	return DatePart("n",tm);
} var minute=Minute; var MINUTE=Minute;

//vbScript Second
function Second(tm) {
	return DatePart("s",tm);
} var second=Second; var SECOND=Second;

//vbScript CStr function: Cstr(value)
function CStr(val) {
   if (typeof(val)==undefined) {return 'undefined'};
	if (isNumeric(val)) {
		return val.toString();
	}
	if (val==true) {
		return 'True';
	} else if (val==false) {
		return 'False';
	}
	return val=val.toString();
} var cstr=CStr; var cStr=CStr; var Cstr=CStr; var CSTR=CStr;

//vbScript FormatDateTime function: FormatDateTime(date,format)
// thanks to Rob Eberhardt of Slingshot Solutions for free use of partial versions of the vbScript native Date functions 
// many of these Date functions have been modified from the original author's design
function FormatDateTime(thedate, df) {
	var vbGeneralDate=0; var vbLongDate=1; var vbShortDate=2; var vbLongTime=3; var vbShortTime=4;
	var vbYYYYMMDD=5; var vbDDdotMMdotYY=6; var vbDDdotMMdotYYYY=7;
	var vbYYslashMMslashDD=8; var vbDDslashMMslashYY=9; var vbYYYYhyphenMMhyphenDD=10;
	var datstr=thedate.toString();
	if(datstr.toUpperCase().substring(0,3) == "NOW") {
		thedate = new Date();
	};
	if(!CvDate(thedate)){ return null; }
	var dt = CvDate(thedate);
	
	//add custom date formats
	if (!df || df==null || df=='undefined') {
		//skip custom date formats
	} else {
		var newdf = df.toString().replace(/\s*/g,'').toUpperCase();
		if (newdf=="DD.MM.YY") { return Format(thedate, 'DD.MM.YY'); }
		if (newdf=="DD.MM.YYYY") { return Format(thedate, 'DD.MM.YYYY'); }
		if (newdf=="DD/MM/YY") { return Format(thedate, 'DD/MM/YY'); }
		if (newdf=="DD/MM/YYYY") { return Format(thedate, 'DD/MM/YYYY'); }
		if (newdf=="DD-MM-YY") { return Format(thedate, 'DD-MM-YY'); }
		if (newdf=="DD-MM-YYYY") { return Format(thedate, 'DD-MM-YYYY'); }
		if (newdf=="DDMMYY") { return Format(thedate, 'DDMMYY'); }
		if (newdf=="DDMMYYYY") { return Format(thedate, 'DDMMYYYY'); }

		if (newdf=="YY.MM.DD") { return Format(thedate, 'YY.MM.DD'); }
		if (newdf=="YYYY.MM.DD") { return Format(thedate, 'YYYY.MM.DD'); }
		if (newdf=="YY/MM/DD") { return Format(thedate, 'YY/MM/DD'); }
		if (newdf=="YYYY/MM/DD") { return Format(thedate, 'YYYY/MM/DD'); }
		if (newdf=="YY-MM-DD") { return Format(thedate, 'YY-MM-DD'); }
		if (newdf=="YYYY-MM-DD") { return Format(thedate, 'YYYY-MM-DD'); }
		if (newdf=="YYMMDD") { return Format(thedate, 'YYMMDD'); }
		if (newdf=="YYYYMMDD") { return Format(thedate, 'YYYYMMDD'); }

		if (newdf=="MM.DD.YY") { return Format(thedate, 'MM.DD.YY'); }
		if (newdf=="MM.DD.YYYY") { return Format(thedate, 'MM.DD.YYYY'); }
		if (newdf=="MM/DD/YY") { return Format(thedate, 'MM/DD/YY'); }
		if (newdf=="MM/DD/YYYY") { return Format(thedate, 'MM/DD/YYYY'); }
		if (newdf=="MM-DD-YY") { return Format(thedate, 'MM-DD-YY'); }
		if (newdf=="MM-DD-YYYY") { return Format(thedate, 'MM-DD-YYYY'); }
		if (newdf=="MMDDYY") { return Format(thedate, 'MMDDYY'); }
		if (newdf=="MMDDYYYY") { return Format(thedate, 'MMDDYYYY'); }
	}

	if(isNaN(df)){ df = vbGeneralDate };

	switch(Math.floor(df)){
		case vbGeneralDate: 	return dateadd("s",0,dt); //0
		case vbLongDate:		return Format(thedate, 'DDDD, MMMM D, YYYY'); //1
		case vbShortDate:		return Format(thedate, 'M/DD/YYYY'); //2
		case vbLongTime:		return Format(thedate, 't t t t t'); //3
		case vbShortTime:		return Format(thedate, 'HH:MM'); //4
		case vbYYYYMMDD:		return Format(thedate, 'YYYYMMDD'); //5
		case vbDDdotMMdotYY:	return Format(thedate, 'DD.MM.YY'); //6
		case vbDDdotMMdotYYYY:	return Format(thedate, 'DD.MM.YYYY'); //7
		case vbYYslashMMslashDD:	return Format(thedate, 'YY/MM/DD'); //8
		case vbDDslashMMslashYY:	return Format(thedate, 'DD/MM/YY'); //9
		case vbYYYYhyphenMMhyphenDD:	return Format(thedate, 'YYYY-MM-DD'); //10
		default:	return null;
	}
} var formatDateTime=FormatDateTime; var formatdateTime=FormatDateTime; var formatdatetime=FormatDateTime; var FORMATDATETIME=FormatDateTime;

function Format(thedate, dfmt, fdow, fdoy) {
	var pmtest=0;
	thedate=thedate.toString();
	if (thedate.match(/\d{1,2}\s*:\s*\d{2}/)) {
		if(thedate.match(/^\s*\d{1,2}\s*:\s*\d{2}/)) { thedate='1/1/2001 '+thedate; }
		if (thedate.match(/\d{1,2}\s*pm/i)) { pmtest=1; }
	}
	if(!CvDate(thedate)){	return null;	}
	if(!dfmt || dfmt==''){	return dt.toString()	};

	var dt = CvDate(thedate);
	// Zero-padding formatter
	this._NSB_pad = function(p_str){
		if(p_str.toString().length==1){p_str = '0' + p_str}
		return p_str;
	}

	var ampm = dt.getHours()>=12 ? 'PM' : 'AM'
	var hr = dt.getHours();
	if (pmtest==1 && hr < 12) { hr +=12; }
	if (hr == 0){hr = 12};
	if (hr > 12) {hr -= 12};
	if (hr<10) { hr = '0'+Math.floor(hr).toString(); }
	var strShortTime = hr +':'+ this._NSB_pad(dt.getMinutes()) +':'+ this._NSB_pad(dt.getSeconds()) +' '+ ampm;
	var strShortDate = (dt.getMonth()+1) +'/'+ dt.getDate() +'/'+ (new _jsString( dt.getFullYear() ) + '').substring(2,4);
	var strLongDate = MonthName(dt.getMonth()+1) +' '+ dt.getDate() +', '+ dt.getFullYear();

	var retVal = dfmt;

	// switch tokens whose alpha replacements could be accidentally captured
	retVal = retVal.replace( new RegExp('C', 'gi'), 'CCCC' ); 
	retVal = retVal.replace( new RegExp('mmmm', 'gi'), 'XXXX' );
	retVal = retVal.replace( new RegExp('mmm', 'gi'), 'XXX' );
	retVal = retVal.replace( new RegExp('dddddd', 'gi'), 'AAAAAA' ); 
	retVal = retVal.replace( new RegExp('ddddd', 'gi'), 'AAAAA' ); 
	retVal = retVal.replace( new RegExp('dddd', 'gi'), 'AAAA' );
	retVal = retVal.replace( new RegExp('ddd', 'gi'), 'AAA' );
	retVal = retVal.replace( new RegExp('timezone', 'gi'), 'ZZZZ' );
	retVal = retVal.replace( new RegExp('time24', 'gi'), 'TTTT' );
	retVal = retVal.replace( new RegExp('time', 'gi'), 'TTT' );
	// now do simple token replacements
	retVal = retVal.replace( new RegExp('am/pm', 'g'), dt.getHours()>=12 ? 'pm' : 'am');
	retVal = retVal.replace( new RegExp('AM/PM', 'g'), dt.getHours()>=12 ? 'PM' : 'AM');
	retVal = retVal.replace( new RegExp('a/p', 'g'), dt.getHours()>=12 ? 'p' : 'a');
	retVal = retVal.replace( new RegExp('A/P', 'g'), dt.getHours()>=12 ? 'P' : 'A');
	retVal = retVal.replace( new RegExp('AMPM', 'g'), dt.getHours()>=12 ? 'pm' : 'am');
	retVal = retVal.replace( new RegExp('yyyy', 'gi'), dt.getFullYear() );
	retVal = retVal.replace( new RegExp('yy', 'gi'), (new _jsString( dt.getFullYear() ) + '').substring(2,4) );
	retVal = retVal.replace( new RegExp('y', 'gi'), DatePart("y", dt) );
	retVal = retVal.replace( new RegExp('q', 'gi'), DatePart("q", dt) );
	retVal = retVal.replace( new RegExp('hh:mm', 'gi'), 'hh:'+this._NSB_pad(dt.getMinutes()) );
	
	retVal = retVal.replace( new RegExp('mm', 'gi'), this._NSB_pad(dt.getMonth() + 1) );
//	retVal = retVal.replace( new RegExp('(?!p|m)m', 'gi'), (dt.getMonth() + 1) );	
	retVal = retVal.replace( new RegExp('(a|p)m', 'g'), '$1x' );	
	retVal = retVal.replace( new RegExp('(A|P)M', 'g'), '$1X' );	
	retVal = retVal.replace( new RegExp('m', 'gi'), (dt.getMonth() + 1) );	
	retVal = retVal.replace( new RegExp('(a|p)x', 'g'), '$1m' );	
	retVal = retVal.replace( new RegExp('(A|P)X', 'g'), '$1M' );
	
	retVal = retVal.replace( new RegExp('dd', 'gi'), this._NSB_pad(dt.getDate()) );
	retVal = retVal.replace( new RegExp('d', 'gi'), dt.getDate() );
	retVal = retVal.replace( new RegExp('hh', 'gi'), this._NSB_pad(dt.getHours()) );
	retVal = retVal.replace( new RegExp('h', 'gi'), dt.getHours() );
	retVal = retVal.replace( new RegExp('nn', 'gi'), this._NSB_pad(dt.getMinutes()) );
	retVal = retVal.replace( new RegExp('n', 'gi'), dt.getMinutes() );
	retVal = retVal.replace( new RegExp('ss', 'gi'), this._NSB_pad(dt.getSeconds()) ); 
	retVal = retVal.replace( new RegExp('s', 'gi'), dt.getSeconds() ); 
	retVal = retVal.replace( new RegExp('t t t t t', 'gi'), strShortTime ); 
	// (always proceed largest same-lettered token to smallest)
	// now finish the previously set-aside tokens 
	retVal = retVal.replace( new RegExp('XXXX', 'gi'), MonthName(dt.getMonth()+1, false) );	//
	retVal = retVal.replace( new RegExp('XXX',  'gi'), MonthName(dt.getMonth()+1, true ) );	//
	retVal = retVal.replace( new RegExp('AAAAAA', 'gi'), strLongDate ); 
	retVal = retVal.replace( new RegExp('AAAAA', 'gi'), strShortDate ); 
	retVal = retVal.replace( new RegExp('AAAA', 'gi'), WeekdayName(dt.getDay()+1, false, fdow) );	// 
	retVal = retVal.replace( new RegExp('AAA',  'gi'), WeekdayName(dt.getDay()+1, true,  fdow) );	// 
	retVal = retVal.replace( new RegExp('TTTT', 'gi'), dt.getHours() + ':' + this._NSB_pad(dt.getMinutes()) );
	retVal = retVal.replace( new RegExp('TTT',  'gi'), hr +':'+ this._NSB_pad(dt.getMinutes()) +' '+ ampm );
	retVal = retVal.replace( new RegExp('CCCC', 'gi'), strShortDate +' '+ strShortTime ); 

	// finally timezone
	var tz = dt.getTimezoneOffset();
	var timezone = (tz<0) ? ('GMT-' + tz/60) : (tz==0) ? ('GMT') : ('GMT+' + tz/60);
	retVal = retVal.replace( new RegExp('ZZZZ', 'gi'), timezone );

	return retVal;
} var FORMAT=Format; var format=Format;

function Month(sdt) {
	var dt=new Date(sdt).getMonth()+1;
	return dt;
} var MONTH=Month; var month=Month;

function MonthName(themonth, dabbr) {
	var MonthNames = [null,nsbx.messages['January'],nsbx.messages['February'],nsbx.messages['March'],nsbx.messages['April'],nsbx.messages['May'],nsbx.messages['June'],nsbx.messages['July'],nsbx.messages['August'],nsbx.messages['September'],nsbx.messages['October'],nsbx.messages['November'],nsbx.messages['December']];
	if(isNaN(themonth)){	// v0.94- compat: extract real param from passed date
		if(!CvDate(themonth)){	return null;	}
//		themonth = DatePart("m", Date.CvDate(themonth));
		themonth = DatePart("m", CvDate(themonth));
	}

	var retVal = MonthNames[themonth];
	if(dabbr==true){	retVal = retVal.substring(0, 3)	}	// abbr to 3 chars
	return retVal;
} var MONTHNAME=MonthName; var monthName=MonthName;

function WeekdayName(theweekday, dabbr, fdow) {
	var WeekdayNames = [null,nsbx.messages['Sunday'],nsbx.messages['Monday'],nsbx.messages['Tuesday'],nsbx.messages['Wednesday'],nsbx.messages['Thursday'],nsbx.messages['Friday'],nsbx.messages['Saturday']];
	var vbUseSystemDayOfWeek=0; var vbSunday=1; var vbMonday=2; var vbTuesday=3; var vbWednesday=4; var vbThursday=5; var vbFriday=6; var vbSaturday=7;
	if(isNaN(theweekday)){	// v0.94- compat: extract real param from passed date
		if(!CvDate(theweekday)){	return null;	}
//		theweekday = DatePart("w", Date.CvDate(theweekday));
		theweekday = DatePart("w", CvDate(theweekday));
	}
	var fdow = (isNaN(fdow) || fdow==0) ? vbSunday : Math.floor(fdow);	// set default & cast

	var nWeekdayNameIdx = ((fdow-1 + Math.floor(theweekday)-1 +7) % 7) + 1;	// compensate nWeekdayNameIdx for fdow
	var retVal = WeekdayNames[nWeekdayNameIdx];
	if(dabbr==true){	retVal = retVal.substring(0, 3)	}	// abbr to 3 chars
	return retVal;
} var WEEKDAYNAME=WeekdayName; var weekDayName=WeekdayName; var weekdayName=WeekdayName; var weekdayname=WeekdayName;

//vbScript Day function: Day(date)
function Day(thedate) {
	if (IsDate(thedate)) {
		if (!isObject(thedate)) {
			thedate=CvDate(thedate);
		}
		return thedate.getDate();
	} else {
		return null;
	}
} var day=Day; var DAY=Day;

//vbScript DateSerial(year, month, day)
function DateSerial(yy, mm, dd) {
	return FormatDateTime(cvdate(mm+'/'+dd+'/'+yy),2);
} var dateSerial=DateSerial; var dateSERIAL=DateSerial; var DateSERIAL=DateSerial; var dateserial=DateSerial; var DATESERIAL=DateSerial;

//vbScript DateValue(dateString)
function DateValue(dateString) {
	return FormatDateTime(cvdate(dateString),2);
} var dateValue=DateValue; var dateVALUE=DateValue; var DateVALUE=DateValue; var datevalue=DateValue; var DATEVALUE=DateValue;

//vbScript IsEmpty
function IsEmpty( theValue ) { 
	return theValue === undefined ? true : false; 
} var isempty=IsEmpty; var isEmpty=IsEmpty; var ISEMPTY=IsEmpty;

//vbScript IsArray
function IsArray(obj) {
	return obj.constructor == Array;
} var isarray=IsArray; var isArray=IsArray; var ISARRAY=IsArray;

//vbScript IsNull
function IsNull(obj) {
	return obj == null
} var isnull=IsNull; var isNull=IsNull; var ISNULL=IsNull;

//vbScript IsObject
function IsObject(obj) {
	return obj.constructor == Object;
	//return typeOf(obj) == "Object";
} var isobject=IsObject; var isObject=IsObject; var ISOBJECT=IsObject;

//vbScript CHR()
function Chr(nmbr) {
//	return String.fromCharCode(nmbr);
	return _jsString.fromCharCode(nmbr);
} var ChrB=Chr; var ChrW=Chr; var chr=Chr; var chrB=Chr; var chrW=Chr; var CHRB=Chr; var CHRW=Chr; var CHR=Chr; var Chrb=Chr; var Chrw=Chr

//vbScript ASC()
function Asc(str) {
	return str.charCodeAt(0);
} var AscB=Asc; var AscW=Asc; var ascB=Asc; var ascW=Asc; var asc=Asc; var ASCB=Asc; var ASCW=Asc; var ASC=Asc; var Ascb=Asc; var Ascw=Asc

//vbScript Join function: Join(s,c)
function Join(str,chr) {
	if (chr=="") { chr=""; } else {
		if (!chr || chr==null) { chr=" "; }
	}
	return str.join(chr);
} var join=Join; var JOIN=Join;

//vbScript Filter function : Filter(srchStr, fndStr, incl, filter)
function Filter(srchStr, fndStr, incl, fil_ter) {
	var origSrchStr = srchStr;
	if (!fndStr || fndStr==null) {fndStr="";}
	if(!fil_ter || fil_ter==null) {fil_ter=0; }
	if (incl==false) {
	} else {
		if(!incl || incl==null) {incl=true; }
	}
	fil_ter = (fil_ter==1) ? 1 : 0;	//0=binary compare, 1=text compare
	incl = (incl == false) ? false : true; //true=include, false=exclude
	if (typeof(srchStr) != 'object') {return '';}
	if (fil_ter==1) {
		fndStr=fndStr.toLowerCase();
	}
	var na=new Array();
	var j=0, ss;
	for(var i=0; i<srchStr.length; i++) {
		if (fil_ter==1) {
			ss=srchStr[i].toLowerCase();
		} else {
			ss=srchStr[i];
		}
		var sso=origSrchStr[i];
		if (incl==true && ss.indexOf(fndStr) > -1) {
			na[j]=sso;
			j++;
		} else {
			if (incl==false && ss.indexOf(fndStr) == -1) {
				na[j]=sso;
				j++;
			}
		}
	}
	return na;
} var filter=Filter; var FILTER=Filter;

//vbScript InStrRev function : InStrRev(string1,string2[,start[,compare]])
function InStrRev(srchStr, fndStr, start, cmp) {
	if (!fndStr || fndStr==null) {fndStr="";}
	if (!cmp) {cmp=0;}
	srchStr.toString();
	if (cmp==1) {
		srchStr=srchStr.toLowerCase();
		fndStr=fndStr.toLowerCase();
	}
	if (!start || !isNumeric(start)) {start=-1;}
	if (start>-1) {
		srchStr=srchStr.substr(0,start);
	}
	var loc;
	if (fndStr == "" ) {
		loc=srchStr.length;
	} else {
		loc=srchStr.lastIndexOf(fndStr)+1;
	}
	return loc;
} var instrrev=InStrRev; var inStrRev=InStrRev; var INSTRREV=InStrRev; var InstrRev=InStrRev;

//vbScript InStr function : InStr([start,]string1,string2[,compare])
function InStr(start, srchStr, fndStr) {
//	if (!start || start==null || !isNumeric(start) || start=='' || start < 1 || !fndStr || fndStr==null) {
	if (!fndStr || fndStr==null || fndStr=="") {
		if (fndStr == "") {
			if (!start || start==null || !isNumeric(start) || start=='' || start < 1 ) { start=1; }
			start=Math.floor(start);
			if (!srchStr || srchStr==null) { srchStr=''; }
			if (start > srchStr.toString().length) { return 0; }
			return start;
		}
		fndStr=srchStr;
		srchStr=start;
		start=1;
	}
	if (!start || start==null || !isNumeric(start) || start=='' || start < 1 ) { start=1; }
	if (!srchStr || srchStr==null) { srchStr=''; }
	if (!fndStr || fndStr==null) { fndStr=''; }
	start=Math.floor(start);

	if (srchStr == "") { return 0; }
	var osrchStr=srchStr.toString();
	if (start > osrchStr.length) { return 0; }
	if (fndStr == "") { return start; }
	
	srchStr=osrchStr;
	fndStr=fndStr.toString();
	if (start>1) { srchStr=srchStr.substr(start-1); }
	if (srchStr.indexOf(fndStr) == -1) { return 0; }
	var loc=srchStr.indexOf(fndStr)+1+(start-1);
	return loc;
} var instr=InStr; var inStr=InStr; var INSTR=InStr;

//vbScript Space function: Space(n)
function Space(c) {
	return (new Array(c+1)).join(' ');
} var space=Space; var SPACE=Space;

//vbScript String function: String(n,c)
//javascript String object has name changed to _jsString to allow for vbScript STRING function
function _vbsSTRING(n,c) {
	if (!n || n==null) {
		return '';
	} else {
		if (!c || c==null) {
			return (n.toString());
		} else {
			c=c.toString().substr(0,1);
			return (new Array(n+1)).join(c);
		}
	}
} var _vbsstring=_vbsSTRING; var _vbsString=_vbsSTRING;

//vbScript StrCmp function: StrComp(string1,string2[,compare])
function StrComp(str1, str2, compare, typ) {
	typ = (typ==1) ? 1 : 0;	//0=binary compare, 1=text compare
	if (typ==0) {
		str1=str1.toLowerCase();
		str2=str2.toLowerCase();
	}
	return ( ( str1 == str2 ) ? 0 : ( ( str1 > str2 ) ? 1 : -1 ) );
} var strcomp=StrComp; var strComp=StrComp; var strcmp=StrComp; var strCmp=StrComp; var StrCmp=StrComp; var STRCOMP=StrComp;

//vbScript Split function: Split(expression[,delimiter[,count[,compare]]]) 
function Split(str, del, cnt, cmp) {
	if (!del || del==null || del=="") { del=" "; }
	if (del != "") {
		return str.split(del);
	}
} var split=Split; var SPLIT=Split;

//vbScript Hex function: Hex(n)
function Hex(n) {
	n=Math.round(n);
	if (n < 0) { 
		n = 0xFFFFFFFF + n + 1; 
	} 
	return n.toString(16).toUpperCase();
} var hex=Hex; var HEX=Hex;

//vbScript Oct function: Oct(n)
function Oct(n) {
	n=Math.round(n);
	if (n < 0) { 
		n = 0177777 + n + 1; 
	} 
	return n.toString(8);
} var oct=Oct; var OCT=Oct;

//vbScript LBound function: LBound(arrayname[,dimension]) 
//dimension Optional. Which dimension's lower bound to return. 1 = first dimension, 2 = second dimension, and so on. Default is 1 
function LBound(arr, dm) {
	return 0;
} var lbound=LBound; var lBound=LBound; var LBOUND=LBound;

//vbScript UBound function: UBound(arrayname[,dimension]) 
//dimension Optional. Which dimension's upper bound to return. 1 = first dimension, 2 = second dimension, and so on. Default is 1
//JavaScript will increase the size of the multidim arrays if more array values are added regardless of how array was created
function UBound(arr, dm) {
	if (!dm || dm==null || dm<1) dm=1;
	dm--;
	var rv=null;
	if (dm==0) {
		try { arr[0]==null; rv=Object.keys(arr).length-1; } catch(e) {}
	} else {
		try { arr[dm]==null; rv=arr[dm-1].length; } catch(e) {}
	}
	return rv;
} var ubound=UBound; var uBound=UBound; var UBOUND=UBound;

//dm: array dimensions: create array (d1,d2,d3,d4)
//handle any number of dimensions and indexes
//Thomas Gruber
function createMultiDimArray(dm,b,c,d) {
	var arr=null;
	if (!dm || dm==null) { dm=""; } dm+='';
	if (!b || b==null) { b=""; } b+='';
	if (!c || c==null) { c=""; } c+='';
	if (!d || d==null) { d=""; } d+='';
	if (b != "") dm+=","+b;
	if (c != "") dm+=","+c;
	if (d != "") dm+=","+d;

	var dms=split(dm.replace(/\s/g,'').replace(/,,/g,',').replace(/,+$/,''),","); //no whitespace, no double comma's, no ending comma
	var dmsctr=(dms==""?0:dms.length)-1;
	if (dmsctr<0) {
		//single dimension array without parameters
		arr=[]; //array[]
		return arr;
	}
	currdim = 0;
	arr = _NSBsubCreateArray(arr,dmsctr,dms,currdim);
	return arr;
}        

//Thomas Gruber
function _NSBsubCreateArray(arr,dmsctr,dms,currdim) {
	var ub=null
	ub = dms[currdim]*1+1;
	arr = new Array(ub);
	if (currdim<dmsctr)  {
		for(var i=0;i<ub;i++)  {
			currdim = currdim+1;
			arr[i] = _NSBsubCreateArray(arr,dmsctr,dms,currdim);
			currdim = currdim-1;
		}
	}
	return arr;
}

//vbScript Time()
function Time() {
   var now    = new Date();
   var hour   = now.getHours();
   var minute = now.getMinutes();
   var second = now.getSeconds();
   var ap = "AM";
   if (hour   > 11) { ap = "PM";             }
   if (hour   > 12) { hour = hour - 12;      }
   if (hour   == 0) { hour = 12;             }
   if (hour   < 10) { hour   = "0" + hour;   }
   if (minute < 10) { minute = "0" + minute; }
   if (second < 10) { second = "0" + second; }
   var timeString = hour + ':' + minute + ':' + second + " " + ap;
   return timeString;
} var time=Time; var TIME=Time;

//vbScript Hour()
function Hour() {
   var now = new Date();
   return now.getHours();
} var hour=Hour; var HOUR=Hour;

//vbScript ERASE
function _erase(arr) {
	for(var i=0; i<arr.length; i++) {
		arr[i]='';
	}
} var _Erase=_erase; var _ERASE=_erase;

//vbScript VARTYPE
function VARTYPE(arg,txt) {
	/*
	vbEmpty	0	Uninitialized (default)
	vbNull	1	No valid data
	vbInteger	2	Integer
	vbLong	3	Long integer
	vbSingle	4	Single-precision floating-point
	vbDouble	5	Double-precision floating-point
	vbCurrency	6	Currency
	vbDate	7	Date
	vbString	8	String
	vbObject	9	Object
	vbError	10	Error
	vbBoolean	11	Boolean
	vbVariant	12	Variant (only with arrays of Variants)
	vbDataObject	13	Data-access object
	vbByte	17	Byte
	vbArray	8192	Array
	*/
	if (!txt || txt==null) { txt=0; } //vartype() vs. typename(); txt==0 if vartype
	var res=-1;
	if (!arg && arg != null) {
		res=0;
		if (txt==1) { return 'empty'; } //typename
	} else if (arg==null) {
		res=1;
		if (txt==1) { return 'null'; } //typename
	} else {
		var type='';
		var typ=typeof arg;
		arg=arg.toString();
		if (type == '' && (arg==1 || arg==0) ) { type='number'; }
		if (type == '' && (arg==true || arg==false || arg=='true' || arg=='false') ) { type='boolean'; res=11;}
		if (type == '' && arg.match(/\s*\d{1,2}(\/|-)\d{1,2}(\/|-)\d{2,4}/) && arg != "NaN") { type='date'; }
		if (type == '' && arg.match(/\s*\w{3}\s+\w{3}\s+\d{2}\s+\d{4}\s+\d{2}:\d{2}:\d{2}\s+\w{3}[\+\-]\d{4}/) && arg != "NaN") { type='date'; }
		if (type == '' && arg.match(/\s*(\d{1,2})(\s+|\s*\-\s*)([a-z]{3})(\s+|\s*\-\s*)(\d{2})($|\s+)/) && arg != "NaN") { type='date'; }
		if (type == '' && arg.match(/\s*\d{4}[\/\-]\d{1,2}[\/\-]\d{1,2}/) && arg != "NaN") { type='date'; }
		if (type == '' && arg.match(/\s*\d{1,2}(\s+|\s*\-\s*)[a-z]{3}(\s+|\s*\-\s*)(\d{2}|\d{4})\s*/) && arg != "NaN") { type='date'; }
		if (type == '' && arg.match(/\s*[a-z]+\s+\d{1,2},?\s+(\d{2}|\d{4})\s*/) && arg != "NaN") { type='date'; }
		if (type == '' && arg.match(/\d{1,2}\/\d{1,2}\/(\d{2}|\d{4})/) && arg != "NaN") { type='date'; }
		if (type == '' && arg[1] && typ=='object') { type='array'; }
		if (type == '' && arg.match(/[a-zA-z]\d/)) { type='string'; }
		if (type == '' && arg.match(/\d[a-zA-z]/)) { type='string'; }
		if (type == '' && arg.match(/\s*\$\d+,*\d*\.*\d*/)) { type='currency'; }
		if (type == '' && arg.match(/\d\.\d/)) { type='double'; }
		if (type == '' && arg.match(/\d/)) { type='integer'; }
		if (type == '') { type = typeof arg; }
		
		if (txt==1) { //typename()
			if (res==0 || res==1) { type='null'; }
			if (type=='array') { type='object'; }
			return type;
		}
		
		switch (type) {
			case 'date': res=7; break;
			case 'integer': res=2; break;
			case 'double': res=5; break;
			case 'currency': res=6; break;
			case 'string': res=8; break;
			case 'object': res=9; break;
			case 'boolean': reg=11; break;
			case 'array': res=8192; break;
			default: res=type; break;
		}
	}
	return res;
} var vartype=VARTYPE; var varType=VARTYPE; var VarType=VARTYPE; var Vartype=VARTYPE;

//vbScript typeName
function TypeName(ele) {
	return vartype(ele, 1);
	/*
	var tmpNumStr = new _jsString(ele);
	if (ele==null) { return null; }
	if (typeof(ele)=='number') {
		if (tmpNumStr.indexOf(".") > -1) { return 'double'; }
		return 'integer';
	}
	return typeof(ele);
	*/
} var typename=TypeName; var typeName=TypeName; var TYPENAME=TypeName; var Typename=TypeName;

function FormatNumber(num,decimalNum,bolLeadingZero,bolParens,bolCommas) {
    if (isNaN(Math.floor(num))) return "NaN";

	var tmpNum = num;
	var iSign = num < 0 ? -1 : 1;		// Get sign of number
	if (!decimalNum || decimalNum==null || decimalNum < 0) { decimalNum=0; }
	if (!bolLeadingZero && bolLeadingZero != false || bolLeadingZero==null) { bolLeadingZero=true; }
	if (!bolParens && bolParens != false || bolParens==null) { bolParens=false; }
	if (!bolCommas && bolCommas != false || bolCommas==null) { bolCommas=true; }
	
	tmpNum = Math.round(Math.abs(tmpNum*Math.pow(10,decimalNum)))/Math.pow(10,decimalNum)*iSign;
	
	// Create a string object to do our formatting on
	var tmpNumStr = new _jsString(tmpNum);

	// See if we need to strip out the leading zero or not.
	if (!bolLeadingZero && num < 1 && num > -1 && num != 0) {
		if (num > 0) {
			tmpNumStr = tmpNumStr.substring(1,tmpNumStr.length);
		} else {
			tmpNumStr = "-" + tmpNumStr.substring(2,tmpNumStr.length);
		}
	}
	
	// See if we need to put in the commas
	var iStart;
	if (bolCommas && (num >= 1000 || num <= -1000)) {
		iStart = tmpNumStr.indexOf(".");
		if (iStart < 0) {
			iStart = tmpNumStr.length;
		}

		iStart -= 3;
		while (iStart >= 1) {
			tmpNumStr = tmpNumStr.substring(0,iStart) + "," + tmpNumStr.substring(iStart,tmpNumStr.length)
			iStart -= 3;
		}		
	}

	// add additional zeroes after decimal point
	iStart = tmpNumStr.indexOf(".");
	var decStr, intStr, totLen;
	if (iStart > -1) {
		decStr=tmpNumStr.substr(iStart+1,tmpNumStr.length);
		intStr=tmpNumStr.substr(0,iStart);
	} else {
		decStr="";
		intStr=tmpNumStr;
		iStart=tmpNumStr.length;
	}
	if (decStr.length < decimalNum) {
		totLen=(decimalNum-decStr.length);
		for(var di=0;di<totLen;di++) {
			decStr=decStr.toString() + '0'.toString();
		}
		intStr=tmpNumStr.substr(0,iStart);
		tmpNumStr=intStr+'.'+decStr
	}

	// See if we need to use parenthesis
	if (bolParens && num < 0) {
		tmpNumStr = "(" + tmpNumStr.substring(1,tmpNumStr.length) + ")";
	}

	return tmpNumStr;		// Return our formatted string!
} var FORMATNUMBER=FormatNumber; var formatNumber=FormatNumber; var formatnumber=FormatNumber;

function FormatPercent(num,decimalNum,bolLeadingZero,bolParens,bolCommas) {
	var tmpNumStr = new _jsString(FormatNumber(num*100,decimalNum,bolLeadingZero,false,bolCommas));

	// See if we need to use parenthesis
	if (bolParens && num < 0) {
		tmpNumStr = "(" + tmpNumStr.substring(1,tmpNumStr.length) + "%)";
	} else {
		tmpNumStr += '%';
	}
	return tmpNumStr;
} var FORMATPERCENT=FormatPercent; var formatPercent=FormatPercent; var formatpercent=FormatPercent;

function FormatCurrency(num,decimalNum,bolLeadingZero,bolParens,bolCommas) {
 	decimalNum=decimalNum<0?2:decimalNum;
	var tmpStr = new _jsString(FormatNumber(num,decimalNum,bolLeadingZero,bolParens,bolCommas));

	if (tmpStr.indexOf("(") != -1 || tmpStr.indexOf("-") != -1) {
		// We know we have a negative number, so place '$' inside of '(' / after '-'
		if (tmpStr.charAt(0) == "(")
			tmpStr = "($"  + tmpStr.substring(1,tmpStr.length);
		else if (tmpStr.charAt(0) == "-")
			tmpStr = "-$" + tmpStr.substring(1,tmpStr.length);
			
		return tmpStr;
	}
	else
		return "$" + tmpStr;		// Return formatted string!
} var FORMATCURRENCY=FormatCurrency; var formatCurrency=FormatCurrency; var formatcurrency=FormatCurrency;

//vbScript TimeValue
function TimeValue(tm) {
	return FormatDateTime(tm,3);
} var timevalue=TimeValue; var timeValue=TimeValue; var TIMEVALUE=TimeValue;

//vbScript TimeSerial
function TimeSerial(hh,mm,ss) {
	if (!ss || ss==null || ss=="") { ss='00'; }
	if (!mm || mm==null || mm=="") { mm='00'; }
	var ssval=parseInt(ss.toString());
	var mmval=parseInt(mm.toString());
	var hhval=parseInt(hh.toString());
	if (ssval>59) {
		ssval=ssval-60;
		mmval++;
	}
	if (mmval>59) {
		mmval=mmval-60;
		hhval++;
	}
	if (hhval > 23) { hhval=hhval-24; }
	hh=hhval.toString(); if (hh.length==1) { hh='0'+hh; }
	mm=mmval.toString(); if (mm.length==1) { mm='0'+mm; }
	ss=ssval.toString(); if (ss.length==1) { ss='0'+ss; }
	return TimeValue(hh+':'+mm+':'+ss);
} var timeserial=TimeSerial; var timeSerial=TimeSerial; var TIMESERIAL=TimeSerial;

//vbScript Rnd (sort of)
function rnd() {
	return Math.random()%1;
} var RND=rnd; var Rnd=rnd;

//vbScript sleep n
function _pause(millis) {
	var date = new Date();
	var curDate = null;
	do { curDate = new Date(); }
	while(curDate-date < millis);
}

//vbscript sysinfo()
function sysinfo(arg) {
	switch(arg) {
		case 0: return screen.width;
		case 1: return screen.height;
		case 2: return window.innerWidth;
		case 3: return window.innerHeight;
        case 10: return new Date().getTime();
		case 108: return screen.availWidth;
		case 109: return screen.availHeight;
		case 188: return screen.width;
		case 190: return screen.height;
		default: return 0;
	}
} var sysInfo=sysinfo; var SYSINFO=sysinfo; var SysInfo=sysinfo; var Sysinfo=sysinfo;

function RGB(r,g,b)  {
	//return '#'+(r + 256 * g + 65536 * b).toString(16).toUpperCase();
	return '#'+(right('00'+hex(r),2) + right('00'+hex(g),2) + right('00'+hex(b),2));
} var rgb=RGB;

//vbScript "\" opterator: integer division
function intDiv(v1, v2) {
	if (!v1) { v1=0; }
	if (!v2) { v2=0; }
	if (v1==null || v2==null) { return null; }
	if (v1==0 || v2==0) { return 0; }
	return (v1 % v2);
} var intdiv=intDiv; var IntDiv=intDiv; var Intdiv=intDiv; var INTDIV=intDiv;

function ucase(arg) {
	if (!arg || arg==null || typeof(arg)=='undefined') { return arg; }
	return arg.toUpperCase();
} var UCASE=ucase; var uCase=ucase; var Ucase=ucase; var UCase=ucase;

function lcase(arg) {
	if (!arg || arg==null || typeof(arg)=='undefined') { return arg; }
	return arg.toLowerCase();
} var LCASE=lcase; var lCase=lcase; var Lcase=lcase; var LCase=lcase;

//vbScript doevents simulation
function doevents() {
	setTimeout("doevents()",100);
} var doEvents=doevents; var DOEVENTS=doevents; var DoEvents=doevents; var Doevents=doevents;

function Sql(db, sqlList){
  //Built in function
	db.transaction(function(transaction){
		for(var i=0; i<sqlList.length; i++)
			sqlex(transaction,sqlList[i]);
	})
}

function sqlex(transaction, sql){
  //Built in function - not called by user directly
	if (typeof(sql)=="string") sql=[sql];
	NSB_lastSQL=sql[0];
	var sql_return = function(){};
	if (sql.length>1) sql_return = sql[1];
	
	var sql_error = sqlError;	
	if (sql.length>2) sql_error=sql[2];
	
	transaction.executeSql(sql[0],[],sql_return,sql_error);
}

function SqlOpenDatabase(shortName, version, displayName, maxSize) {
  //Built in function
	try {
			if (!window.openDatabase) {
					alert(nsbx.messages['SQLite_not_supported']);
			} else {
					if (typeof(shortName) == 'undefined') {
						alert(nsbx.messages["Database_name_required"]);
						return 0;
						}
					if (typeof(version) == 'undefined') version='1.0';
					if (typeof(displayName) == 'undefined') displayName = shortName;
					if (typeof(maxSize) == 'undefined') maxSize =1000000;
					var myDB = openDatabase(shortName, version, displayName, maxSize);
			}
	} catch(e) {
			if (e == 11) {// INVALID_STATE_ERR: Version number mismatch.
			alert(nsbx.messages["Invalid_database_version."]);
			} else {
			alert(nsbx.messages["Unknown_error_"]+e+".");
			}
			return 0;
	}
	return myDB;
}

function sqlError(transaction, error) {
	//Built in function. 
	alert('SQLite error: '+error.message+' (Code '+error.code+') ' + NSB_lastSQL);
	return false;
}

function SQLiteSchema2JSON(db) {
	//convert SQLite database schema to JSON object then store into table _JSONdbSchemaTable table
	/*JSON example of database schema
	{"tables": [

		{"cmd":"CREATE TABLE tbl1 (id REAL UNIQUE, text TEXT)"}
		{"cmd":"CREATE TABLE tbl2 (id REAL UNIQUE, text TEXT)"}
	]}			
	*/
	_nsbJSONsqlData='';
	_nsbJSONSchemaDB=db; //save the db to save the JSON file
	db.transaction(function(tx) {
		tx.executeSql('SELECT name, sql FROM sqlite_master WHERE (type=?)', ["table"], function(tx, result) {
			_nsbJSONSchemaText = '{"tables": [';
			var j=0;
			var sqli=[];
			for (var i = 0, item = null; i < result.rows.length; i++) {
				item = result.rows.item(i);
				if (item['name'] != '__WebKitDatabaseInfoTable__' && item['name'] != '_JSONdbSchemaTable') {
					if (j>0) { _nsbJSONSchemaText += ','; }
					_nsbJSONSchemaText += '{"cmd":"'+item['sql']+'"}';
					_getSQLTableData(db, item['name'], item['sql']);
					j++;
				}





			}
		}); //tx.executeSql
	}); //db.transaction
} //function SQLiteSchema2JSON

function _getSQLTableData(db, tblName, sqlStmt) {
	//display data in each table
	var sqlList=[];
	sqlList[0]=["select '"+tblName+"' as TBLName,'"+sqlStmt+"' as sqlStmt, * from "+tblName+";", _getSQLTableResults];
	Sql(db, sqlList);
} //function _getSQLTableData

function _getSQLTableResults(tx, result) {
	for (i=0, item=null;i<result.rows.length;i++) {
		item=result.rows.item(i);
		var colName='', colData='', j=0;
		var sqlStmt='';
		var fldcol=[];
		var fldtype=[];
		var numTypes='|INT'+'|INTEGER'+'|TINYINT'+'|SMALLINT'+'|MEDIUMINT'+'|BIGINT'+'|UNSIGNED'+'|INT2'+'|INT8'+'|BIG';
		numTypes += '|BLOB'+'|REAL'+'|DOUBLE'+'|FLOAT'+'|NUMERIC'+'|DECIMAL'+'|BOOLEAN'+'|DATE'+'|DATETIME|';
		var charTypes='|CHARACTER'+'|VARCHAR'+'|VARYING'+'|NCHAR'+'|NATIVE'+'|NVARCHAR'+'|TEXT'+'|CLOB|';
		for (fld in item) {
			if (fld=='TBLName') { //save table name for JSON Insert statement
				tblName=item[fld];
			} else if (fld=='sqlStmt') { //break up sql statement getting data types for field names
				if (sqlStmt=='') {
					sqlStmt=item[fld];
					var fldstr=sqlStmt.substring(sqlStmt.indexOf('('));
					var flds=fldstr.substring(1,fldstr.length-1); //only save fields and types
					var flditem='';
					var getType=0, inParen=0, gotoNext=0; //flags for parsing
					fldarray=flds.split(",");
					for (f in fldarray) {
						var flditems=fldarray[f].replace(/^\s*(.*)\s*$/,'$1'); //remove leading and trailing spaces
						flditems=flditems.split(' ');
						flditem=flditems[0]; //get field name
						fldcol.push(flditem); //save field name
						for (m=1; m<flditems.length; ++m) {
							flditem=flditems[m]; //get field type
							if (numTypes.indexOf('|'+flditem+'|')>-1) {
								fldtype.push('n'); //save numeric type
								break;
							} else if (charTypes.indexOf('|'+flditem+'|')>-1) {
								fldtype.push('c'); //save char type
								break;
							}
						}
					}
				} //if(sqlStmt
			} else { //create JSON file for the data
				if (j>0) { colName += ','; colData += ','; }
				colName += fld;
				for(k=0;k<fldtype.length;++k) { //identify field type
					if (fld==fldcol[k]) { ftype=fldtype[k]; }
				}
				if (ftype=='n') {
					colData += item[fld];
				} else {
					colData += "'"+item[fld]+"'";
				}
				j++;
			}
		}
		if (colName != '') { //add insert statement for the data
			_nsbJSONsqlData += ',{"cmd":"insert into '+tblName+ '('+colName+') values ('+colData+')"}';
		}
	}
	new_nsbJSONSchemaText=_nsbJSONSchemaText + _nsbJSONsqlData + ']}';
	new_nsbJSONSchemaText=new_nsbJSONSchemaText.replace(/{"cmd":"\s*CREATE\s+TABLE\s+([\w\[\]\.\-\?\#\$\%\&\!\:]+)/gi,'{"cmd":"DROP TABLE IF EXISTS $1"},{"cmd":"CREATE TABLE $1');
	var jsonObj = JSON.parse(new_nsbJSONSchemaText);
	var jsonStr = JSON.stringify(jsonObj);
	_saveJSONschema(_nsbJSONSchemaDB, jsonStr); //save JSON file
} //function _getSQLTableResults
function _saveJSONschema(dbj, jsonStr) {
	//save schema to _JSONdbSchemaTable table in database
	//jwchk dbj=SqlOpenDatabase("dbJSON", "1.0", "db1", 1048576); //open JSON database
	dbj.transaction(function(tx) {
		tx.executeSql("DROP TABLE _JSONdbSchemaTable", []);
	});
	dbj.transaction(function(tx) {
		tx.executeSql("CREATE TABLE _JSONdbSchemaTable (id INT, schema TEXT)", []);
	});
	dbj.transaction(function(tx) {
		tx.executeSql("INSERT INTO _JSONdbSchemaTable (id, schema) VALUES (?, ?)", [1, jsonStr]);
	});
} //function _saveJSONschema

function JSON2SQLiteSchema(dbj, db) {
	//convert JSON object to SQLite database schema
	/*JSON example of database schema
	{"tables": [
		{"cmd":"CREATE TABLE __WebKitDatabaseInfoTable__ (key TEXT NOT NULL ON CONFLICT FAIL UNIQUE ON CONFLICT REPLACE,value TEXT NOT NULL ON CONFLICT FAIL)"}
		{"cmd":"CREATE TABLE tbl1 (id REAL UNIQUE, text TEXT)"}
		{"cmd":"CREATE TABLE tbl2 (id REAL UNIQUE, text TEXT)"}
	]}			
	*/
	//jwchk var dbj=SqlOpenDatabase("dbJSON", "1.0", "db1", 1048576); //open JSON database
	dbj.transaction(function(tx) {
		tx.executeSql('SELECT schema FROM _JSONdbSchemaTable where id=?', [1], function(tx, result) {
			var jsonObj={};
			i=result.rows.length-1;
			if (i<0) {
				alert('No JSON records were loaded');
			} else {
				item = result.rows.item(i);
				jsonObj=JSON.parse(item['schema']);
				db.transaction(function(tx) {
					for (i=0;i<=ubound(jsonObj.tables);++i) {
						var sqlCmd=jsonObj.tables[i].cmd
						//skip __WebKitDatabaseInfoTable__ and _JSONdbSchemaTable tables
						if (sqlCmd.indexOf('CREATE TABLE __WebKitDatabaseInfoTable__')==-1 && sqlCmd.indexOf('CREATE TABLE _JSONdbSchemaTable')==-1) {
							tx.executeSql(sqlCmd);
						}
					}
					//alert('Database schema has been restored');
				});	
			}
		}); //tx.executeSql
	}); //db.transaction
} //function JSON2SQLiteSchema
function Main(){}

function _navGetLocaleFunc() {
	var lang='';
	if ( navigator ) {
		if ( navigator.language ) {
			lang=navigator.language;
		}
		else if ( navigator.browserLanguage ) {
			lang=navigator.browserLanguage;
		}
		else if ( navigator.systemLanguage ) {
			lang=navigator.systemLanguage;
		}
		else if ( navigator.userLanguage ) {
			lang=navigator.userLanguage;
		}
	}
	return lang;
}

function Log10(x) {
	return Math.log(x)/Math.log(10);
} var log10=Asc; var LOG10=Asc; 

function _jsCint(n) {
	//simulate vbScript CINT()
	var i=Math.floor(n);
	var d=n*1-i-0.5; //get fractional part
	if (d==0) { //d=.5
		if (i%2 == 0) { //even leave as is otherwise inc
			n=i;
		} else {
			n=i*1+1;
		} // end of if d%2
	} else if (d>0) { //greater than .5
		n=i*1+1;
	} else { //less than .5
		n=i;
	}
	return n*1;
} var _jsCINT=_jsCint; var _JSCINT=_jsCint; var _jsCInt=_jsCint; var _JSCInt=_jsCint;

function jsFix(n) {
	//simulate vbScript FIX()
	var i=Math.floor(n);
	if (i<0) { i++; };
	return i*1;
} var jsFIX=jsFix; var JSFIX=jsFix; var JSFix=jsFix;

function readFile(filename,method){
	if (!method || method==null || typeof(method)=='undefined') { method = ''; }
	if(method=="") method="GET";
	req=new XMLHttpRequest();
	req.open(method.toUpperCase(),filename,false);
	try {
		req.send(null)}
	catch(err) {
		req.err=err};
	return req
} var ReadFile=readFile; var readfile=readFile; var READFILE=readFile;

function Ajax(URL, method, data, callback){
  if(!method || method==null || typeof(method)=='undefined') method = "GET";
  if(!data || data==null || typeof(data)=='undefined') data = "";
  var req = new XMLHttpRequest();
  if (callback) req.onreadystatechange=callback;
  if(method.toUpperCase()=="GET"){ 
    if(data!=="") URL+=data;
    data=null}
  req.open(method.toUpperCase(), URL, (callback!=undefined));
  if(method.toUpperCase()=="POST"){ 
    req.setRequestHeader("Content-type", "application/x-www-form-urlencoded")};
  try {
    req.send(data)}
  catch(err) {
    req.err=err}
  return req
}

function nsbDOMAttr(obj, strobj) {
    var parts = strobj.split('.');
    var target = parts[parts.length - 1]
    var setter = arguments.length > 2;
    var value = arguments[2];  // optional, value to be set
    var noscroll = arguments[3];  // optional, don't do scroller exceptions
    
    // special cases for canvas elements
    if ((obj.tagName === 'CANVAS') && setter) {
        if (strobj === 'style.width') obj.width = parseInt(value);
        if (strobj === 'style.height') obj.height = parseInt(value);
    }
    
    // one more exception and this needs to be a list
    if (obj.parentNode && !noscroll && (obj.parentNode.id === (obj.id + '_scroller')) &&
        ((strobj === 'style.left') || (strobj === 'style.top') ||
         (strobj === 'style.width') || (strobj === 'style.height') ||
         (strobj === 'style.display'))) {
        // if setting, set the actual value as well
        if (setter && strobj !== 'style.left' && strobj !== 'style.top') nsbDOMAttr(obj, strobj, value, true);
        // get/set from the parent object
        obj = obj.parentNode;
    }
    
    for (var i = 0; i < parts.length - 1; i++) {
        obj = obj[parts[i]];
    }
    
    if (setter) {
        // set the value
        return obj[target] = value;
    } else {
        // return the value
        return obj[target];
    }
}

function GetURLParameter( name ) {
  name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
  var regexS = "[\\?&]"+name+"=([^&#]*)";
  var regex = new RegExp( regexS );
  var results = regex.exec( window.location.href );
  if( results == null )
    return "";
  else
    return results[1];
} getURLParameter=GetURLParameter;

function enquote(s){
  var i, arrTerms, arrTerm;
  arrTerms=s.split(" ");
  for (i=0; i<arrTerms.length; i++){
    arrTerm=arrTerms[i].split("=");
    if (arrTerm.length>1) {
	  if (arrTerm[1].length==0){
	    arrTerms[i]="";
		}
	  else {
        if (arrTerm[1].substring(0,1)!="'") {
		  arrTerms[i]=arrTerm[0] + "='" + arrTerm[1] + "'"}
		  }
		}
    else 
      if (arrTerms[i].indexOf("=")>0) {
        //arrTerms[i]=arrTerm[0] + "=''"}
        arrTerms[i]=""}
    }
  return arrTerms.join(" ");
  }
  
  
function NSB_oncache(e){
  if (typeof oncache!='undefined'){oncache(e);return;}
  NSB_eCount=NSB_eCount+1;
  if (e.type=="progress"){NSB_showProgress(nsbx.messages["Update_loading"] + (Array(NSB_eCount%35).join(".")))}
    else {NSB_showProgress(e.type);}
  if ((e.type=="noupdate") || (e.type=="cached")){
    NSB_showProgress(false);
  }
  if (e.type=="updateready"){
    NSB_showProgress(nsbx.messages["Update_Complete_-_Restarting."]);
    window.applicationCache.swapCache();
    window.location.reload();
  }
}
  
function NSB_showProgress(s){
  if (s==false){
    if (NSB_Progress.parentNode!=undefined){
      NSB_Progress.parentNode.removeChild(NSB_Progress);}
    return;
  }
  if (typeof(NSB_Progress)=='undefined'){
    NSB_Progress = document.createElement("div");
    NSB_Progress.setAttribute("id", "NSB_Progress");
    NSB_Progress.style.position = "absolute";
    NSB_Progress.style.width = "200px";
    NSB_Progress.style.height = "20px";
    NSB_Progress.style.left = "55px";
    NSB_Progress.style.top = window.innerHeight-100 + "px";
    NSB_Progress.style.background = "black" ;
    NSB_Progress.style.color="white";
    NSB_Progress.style.border = "4px solid black";
    NSB_Progress.style.fontSize="12px";
    NSB_Progress.onclick=function(){NSB_Progress.parentNode.removeChild(NSB_Progress)};
    document.body.appendChild(NSB_Progress);
  }
  NSB_Progress.innerHTML=s;
}

function ChangeForm(newForm, transition, reverse) {
  if (typeof(NSBCurrentForm.onhide)=='function') {NSBCurrentForm.onhide()};
  
  if (false & NSBFramework=="jQuery Mobile"){
    if (typeof(transition)=='undefined') {transition='none'};
    if (reverse!=True) {reverse=false};
    $.mobile.changePage($('#Page_'+newForm.id),{transition: transition.toLowerCase(), reverse: reverse, role: 'dialog'});
  } else {
    NSBCurrentForm.style.display="none";
    newForm.style.display="block"
  }
  NSBCurrentForm=newForm;
  if (typeof(NSBCurrentForm.onshow)=='function') 
    {setTimeout(NSBCurrentForm.onshow, 100)};
}

//Global code

if (typeof navigator !== 'undefined' && navigator.onLine){
	//window.applicationCache.addEventListener("checking", NSB_oncache, false);
	window.applicationCache.addEventListener("downloading", NSB_oncache, false);
	window.applicationCache.addEventListener("noupdate", NSB_oncache, false);
	window.applicationCache.addEventListener("progress", NSB_oncache, false);
	window.applicationCache.addEventListener("updateready", NSB_oncache, false);
	window.applicationCache.addEventListener("cached", NSB_oncache, false);
	window.applicationCache.addEventListener("error", NSB_oncache, false);
	window.applicationCache.addEventListener("obsolete", NSB_oncache, false);
}
var NSB_eCount=0;
var NSB_Progress;

//globals
if (typeof document !== 'undefined') {
    var AppBuildStamp=document.getElementsByName("date")[0].content;
    var AppVersion=document.getElementsByName("version")[0].content;
    var AppLegalCopyright=document.getElementsByName("copyright")[0].content;
    var NSBVersion=document.getElementsByName("generator")[0].content;
    var NSBFramework=(typeof($)=='function')?'jQuery Mobile':'Classic';
}
document.ontouchmove = function(e) {{ e.preventDefault(); }};
/mobile/i.test(navigator.userAgent) && !location.hash && setTimeout(function(){if (!pageYOffset) window.scrollTo(0,0)},500);